A.REG = $030C
X.REG = $030D
Y.REG = $030E
C.REG = $030F

R0L=$02:R0H=$03:R0=R0L

R1L=$04:R1H=$05:R1=R1L

R2L=$06:R2H=$07:R2=R2L

R3L=$08:R3H=$09:R3=R3L

R4L=$A:R4H=$B:R4=R4L

R5L=$C:R5H=$D:R5=R5L

FB.SET.PIXELS = $FF0E
FB.CURSOR.POSITION = $FEFF
FB.CURSOR.NEXTLINE = $FF02
SETLFS = $FFBA
CHKOUT = $FFC9
CHKIN = $FFC6
CLRCHN = $FFCC
MCIOUT = $FEB1
MACPTR = $FF44
VERA.LOWADDR = $9F20
VERA.MIDADDR = $9F21
VERA.HIGHADDR = $9F22
VERA.DATA0 = $9F23
VERA.DATA1 = $9F24
VERA.CTRL = $9F25
VERA.DCVIDEO = $9F29
LAYER0.ON = 16
LAYER0.OFF = 239
LAYER1.ON = 32
LAYER1.OFF = 223
SCREEN.SIZE = $12C00
XLIMIT=319
YLIMIT=239
ZERO=0
NULL=0
FALSE=ZERO
TRUE=NOT FALSE

WHITE$=CHR$(5)
GREEN$=CHR$($1E)
YELLOW$=CHR$($9E)
RED$=CHR$($96)
PETSCII.MODE=$8E
ISO.MODE=$0F


## PUT INCLUDES WITH VARIABLE(PSUEDO CONST) DEFINITIONS ABOVE THE GOTO MAIN

GOTO MAIN

##  THE LABLE MAIN: SHOULD BE BELOW WHERE THIS FILE IS INCLUDED AND BE THE START OF THE PROGRAM

HIDEGRAPHICS:
  POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) AND LAYER0.OFF
  RETURN

SHOWGRAPHICS:
 POKE VERA.DCVIDEO, PEEK(VERA.DCVIDEO) OR LAYER0.ON
 RETURN

REVINSTR:
    ISTR=ZERO
    IF T$="" OR S$="" OR (LEN(S$)>LEN(T$)) THEN RETURN
    S=LEN(S$)
    L=LEN(T$)-(S-1)
TESTLOOP:
    TST$=MID$(T$,L,S)
    IF TST$=S$ THEN ISTR=L
    IF ISTR<>L AND L>1 THEN L=L-1:GOTO TESTLOOP
    RETURN

SPLITNAMEUP:
   T$=FNAME$
   BASE.PATH$="" : BASE.EXT$=""
   IF LEN(FNAME$) > 2 THEN DOSPLIT
   BASE.NAME$=FNAME$:RETURN
DOSPLIT:
   S$=".":GOSUB REVINSTR
   IF ISTR > 0 THEN BASE.EXT$=RIGHT$(FNAME$,LEN(FNAME$)-(ISTR-1))
   IF ISTR > 0 THEN T$=LEFT$(T$,ISTR-1)
   S$="/":GOSUB REVINSTR
   IF ISTR=0 THEN BASE.NAME$=T$:GOTO ALLDONE
   BASE.PATH$=LEFT$(T$,ISTR-1)
   BASE.NAME$=RIGHT$(T$,LEN(T$)-ISTR)
ALLDONE:
   RETURN


GETINIVALUE:
   I=1
GETILOOP:
   IF NN$(I)=I$ THEN I$=NV$(I):RETURN
   I=I+1
   IF I>NV% THEN I$="":RETURN
   GOTO GETILOOP

READINI:
    NV%=0:FV%=0
    GOSUB FILEEXISTS
    IF NOT FE% THEN RETURN
    FF$=F$+ ",S,R"
    OPEN 4,8,4,FF$
    DOINILOOP:
        LINPUT#4, S$
        GOSUB TRIM
        GOSUB UCASE
        IF LEFT$(S$,4)="REM " OR S$="" OR S$="REM" THEN CONTLOOP
        PRINT ".";
        GOSUB GETINIVAR
        IF TN$="" THEN CONTLOOP
        NV%=NV%+1
        NN$(NV%)=TN$:NV$(NV%)=TV$
    CONTLOOP:
       IF ST=0 AND NV%<20 THEN DOINILOOP
    CLOSE 4
    FV%=(NV%>0)
    PRINT:RETURN

GETINIVAR:
       SC$="":TN$="":TV$=""
       J=1
  DOINIPARSE:
       T$=MID$(S$,J,1)
       IF T$="=" THEN GOTINI
       SC$=SC$+T$
       J=J+1:IF J>LEN(S$) THEN ENDINI
       GOTO DOINIPARSE
GOTINI:
       J=J+1
       TT$=S$
       S$=SC$
       SC$=""
       GOSUB RTRIM
       TN$=S$
       S$=TT$
  VALUEPARSE:
       T$=MID$(S$,J,1)
       SC$=SC$+T$
       J=J+1:IF J>LEN(S$) THEN ENDINI
       GOTO VALUEPARSE
ENDINI:
     TT$=S$
     S$=SC$
     GOSUB TRIM
     TV$=S$
     S$=TT$
  RETURN

UCASE:
   IF S$="" THEN RETURN
   SC$=""
   FOR I=1 TO LEN(S$)
       T$=MID$(S$,I,1)
       C1=ASC(T$)
       IF C1>=97 AND C1<=122 THEN C1=C1-32
       SC$=SC$+CHR$(C1)
   NEXT I
   S$=SC$
   RETURN

TRIM:
  GOSUB LTRIM
  GOSUB RTRIM
  RETURN

LTRIM:
    IF S$="" THEN RETURN
    I=1:C1=0
DOLOOP:
    T$=MID$(S$,I,1)
    X=ASC(T$)
    IF X > 32 THEN LSTR
    C1=C1+1
   I=I+1
   IF I>LEN(S$) THEN LSTR
   GOTO DOLOOP
LSTR:
   IF C1=LEN(S$) THEN S$=""
   IF C1>0 AND C1<LEN(S$) THEN S$=MID$(S$,C1+1,LEN(S$)-C1)
   RETURN

RTRIM:
    IF S$="" THEN RETURN
    I=LEN(S$):C1=0
DOLOOPR:
    T$=MID$(S$,I,1)
    X=ASC(T$)
    IF X > 32 THEN RSTR
    C1=C1+1
    I=I-1
    IF I<1 THEN RSTR
    GOTO DOLOOPR
RSTR:
    IF C1=LEN(S$) THEN S$=""
    IF C1>0 AND C1<LEN(S$) THEN S$=MID$(S$,1,LEN(S$)-C1)
    RETURN

## PUT INCLUDES WITH SUBROUTINE DEFINITIONS BELOW GOTO MAIN
REM SET PALLETTE ENTRY P1 TO R%,G%,B%
RGBPAL:
      A=P1*2:GB%=(G%*16)+B%
      A=A+$FA00
      SLEEP:VPOKE 1,A,GB%
      A=A+1
      SLEEP:VPOKE 1,A,R%
      RETURN

REM READ PALLETTE ENTRY AT P1
READPAL:
      A1=$FA00+(P1*2)
      R%=VPEEK(1,A1+1)
      GB%=VPEEK(1,A1)
      G%=GB%/16
      B%=GB% AND $0F
      RETURN

REM FADE P2 FROM CURRENT COLOR TO P1 COLOR, J IS JIFFY DELAY
PAL2PALFADE:
      GOSUB READPAL
      P3=P1:P1=P2
      GOSUB PALFADE
      P1=P3
      RETURN

REM FADE P1 TO R%,G%,B%, J IS JIFFY DELAY
PALFADE:
      DR%=R%:DG%=G%:DB%=B%
      GOSUB READPAL
      RI=1:IF DR%<R% THEN RI=-1
      GI=1:IF DG%<G% THEN GI=-1
      BI=1:IF DB%<B% THEN BI=-1
INCRGB:
      IF DR%<>R% THEN R%=R%+RI
      IF DG%<>G% THEN G%=G%+GI
      IF DB%<>B% THEN B%=B%+BI
      GOSUB RGBPAL
      SLEEP J
      IF DR%=R% AND DG%=G% AND DB%=B% THEN FADEDONE
      GOTO INCRGB
FADEDONE:
      RETURN

REM SWAP PALLETTE COLORS AT P1 & P2
SWAPPAL:
      A1=$FA00+(P1*2):A2=$FA00+(P2*2)
      B1=VPEEK(1,A1):B2=VPEEK(1,A1+1):B3=VPEEK(1,A2):B4=VPEEK(1,A2+1)
      VPOKE 1,A1,B3:VPOKE 1,A1+1, B4
      VPOKE 1,A2,B1:VPOKE 1,A2+1, B2
      RETURN

REM COPY P1 PALLETTE ENTRY TO P2.. P1 IS LEFT UNCHANGED.
COPYPAL:
      VPOKE 1,$FA00+(P2*2),VPEEK(1,$FA00+(P1*2))
      VPOKE 1,$FA00+(P2*2)+1,VPEEK(1,$FA00+(P1*2)+1)
      RETURN

REM SET THE PALLETTE TO ALL BLACK
PAL2BLACK:
    FOR A=$FA00 TO $FBFF:VPOKE 1,A,0:NEXT A:RETURN


REM SET THE VERA DEFAULT PALETTE USE FILE LOAD IF THERE.
SETDEFPAL:
      F$="DPAL.BIN":GOSUB FILEEXISTS
      IF FE% THEN BVLOAD F$,8,1,$FA00:RETURN
      RESTORE PALDATA
REM LOOP THROUGH THE PALLETTE ADDRESS SPACE
REM AND POKE THE VERA DEFAULT PALLETTE
      FOR PE = $FA00 TO $FBFE STEP 2
          READ R:READ GB
          VPOKE 1,PE,GB
          VPOKE 1,PE+1, R
      NEXT PE
      RETURN

SAVEPAL2FILE:
     FF$="@:"+F$+",S,W"
     OPEN 5,8,2,FF$
     FOR PE=$FA00 TO $FBFE STEP 2
         GB=VPEEK(1,PE)
          R=VPEEK(1,PE+1)
         PRINT#5,CHR$(GB);
         PRINT#5,CHR$(R);
     NEXT PE
     CLOSE 5
     RETURN

REM DEFAULT VERA PALLETTE AS DATA. FROM 0 TO 255 (2 BYTES EACH ENTRY)RGB
PALDATA:
      DATA $00,$00,$0F,$FF,$08,$00,$0A,$FE,$0C,$4C,$00,$C5,$00,$0A,$0E,$E7,$0D
      DATA $85,$06,$40,$0F,$77,$03,$33,$07,$77,$0A,$F6,$00,$8F,$0B,$BB,$00,$00
      DATA $01,$11,$02,$22,$03,$33,$04,$44,$05,$55,$06,$66,$07,$77,$08,$88,$09
      DATA $99,$0A,$AA,$0B,$BB,$0C,$CC,$0D,$DD,$0E,$EE,$0F,$FF,$02,$11,$04,$33
      DATA $06,$44,$08,$66,$0A,$88,$0C,$99,$0F,$BB,$02,$11,$04,$22,$06,$33,$08
      DATA $44,$0A,$55,$0C,$66,$0F,$77,$02,$00,$04,$11,$06,$11,$08,$22,$0A,$22
      DATA $0C,$33,$0F,$33,$02,$00,$04,$00,$06,$00,$08,$00,$0A,$00,$0C,$00,$0F
      DATA $00,$02,$21,$04,$43,$06,$64,$08,$86,$0A,$A8,$0C,$C9,$0F,$EB,$02,$11
      DATA $04,$32,$06,$53,$08,$74,$0A,$95,$0C,$B6,$0F,$D7,$02,$10,$04,$31,$06
      DATA $51,$08,$62,$0A,$82,$0C,$A3,$0F,$C3,$02,$10,$04,$30,$06,$40,$08,$60
      DATA $0A,$80,$0C,$90,$0F,$B0,$01,$21,$03,$43,$05,$64,$07,$86,$09,$A8,$0B
      DATA $C9,$0D,$FB,$01,$21,$03,$42,$04,$63,$06,$84,$08,$A5,$09,$C6,$0B,$F7
      DATA $01,$20,$02,$41,$04,$61,$05,$82,$06,$A2,$08,$C3,$09,$F3,$01,$20,$02
      DATA $40,$03,$60,$04,$80,$05,$A0,$06,$C0,$07,$F0,$01,$21,$03,$43,$04,$65
      DATA $06,$86,$08,$A8,$09,$CA,$0B,$FC,$01,$21,$02,$42,$03,$64,$04,$85,$05
      DATA $A6,$06,$C8,$07,$F9,$00,$20,$01,$41,$01,$62,$02,$83,$02,$A4,$03,$C5
      DATA $03,$F6,$00,$20,$00,$41,$00,$61,$00,$82,$00,$A2,$00,$C3,$00,$F3,$01
      DATA $22,$03,$44,$04,$66,$06,$88,$08,$AA,$09,$CC,$0B,$FF,$01,$22,$02,$44
      DATA $03,$66,$04,$88,$05,$AA,$06,$CC,$07,$FF,$00,$22,$01,$44,$01,$66,$02
      DATA $88,$02,$AA,$03,$CC,$03,$FF,$00,$22,$00,$44,$00,$66,$00,$88,$00,$AA
      DATA $00,$CC,$00,$FF,$01,$12,$03,$34,$04,$56,$06,$68,$08,$8A,$09,$AC,$0B
      DATA $CF,$01,$12,$02,$24,$03,$46,$04,$58,$05,$6A,$06,$8C,$07,$9F,$00,$02
      DATA $01,$14,$01,$26,$02,$38,$02,$4A,$03,$5C,$03,$6F,$00,$02,$00,$14,$00
      DATA $16,$00,$28,$00,$2A,$00,$3C,$00,$3F,$01,$12,$03,$34,$05,$46,$07,$68
      DATA $09,$8A,$0B,$9C,$0D,$BF,$01,$12,$03,$24,$04,$36,$06,$48,$08,$5A,$09
      DATA $6C,$0B,$7F,$01,$02,$02,$14,$04,$16,$05,$28,$06,$2A,$08,$3C,$09,$3F
      DATA $01,$02,$02,$04,$03,$06,$04,$08,$05,$0A,$06,$0C,$07,$0F,$02,$12,$04
      DATA $34,$06,$46,$08,$68,$0A,$8A,$0C,$9C,$0F,$BE,$02,$11,$04,$23,$06,$35
      DATA $08,$47,$0A,$59,$0C,$6B,$0F,$7D,$02,$01,$04,$13,$06,$15,$08,$26,$0A
      DATA $28,$0C,$3A,$0F,$3C,$02,$01,$04,$03,$06,$04,$08,$06,$0A,$08,$0C,$09
      DATA $0F,$0B

FILEEXISTS:
   X$=F$:FE%=0:X$=X$+",S,R"
   OPEN 2,8,2,X$:CLOSE 2
   OPEN 15,8,15:INPUT#15,X,X$,A,B
   CLOSE 15:FE%=(X<=20):RETURN
